pt pickedPoint = P();
int vc=32, kc=8;             // vertex and keyframe counts
int k=0;                     // current key frame
Polyloop [] CP= new Polyloop [kc];  // control polyloops
Polyloop C= new Polyloop();  // used to cut and paste
Polyloop P= new Polyloop();  // reference for editing
Polyloop D= new Polyloop();  // used to capture the curve drawn by the user
int style=0;                 // animation style: 0=stroboscopic, 1=linear, 2=...
boolean showFrames=false;        // toggle show all frames
boolean showKeys=false;          // toggle show all keys
boolean animate=false;          // toggle show all keys
boolean showMouseProjection=false;          // toggle show mouse projection
boolean sketching=false;     // toggle indicating that the user is sketching the selected curve
boolean showVertices=true;   // show control vertices
boolean showEkey=true;    // show edited curve
float t=0;                   // current time for animation

void myInit() {for(int i=0; i<kc; i++) CP[i]=new Polyloop(); myReset(); mySelected(0); };
void myReset() {for(int i=0; i<kc; i++) CP[i].reset(vc);};
void mySave() {for(int i=0; i<kc; i++) CP[i].savePts(i);}; 
void myLoad() {for(int i=0; i<kc; i++) CP[i].loadPts(i);}; 
void myDenoise() {P.smoothen(5);}
void mySample() {P.resample(32);}
void myRefine() {P.refine(0,0);}
void myCopy() {C.setTo(CP[k]);}
void myPaste() {CP[k].setTo(C);}
   
void mySelected(int n) {k=n; P=CP[k];}     // user selects curve by typing its number n: select curve
void myStartAcquisition() {D.empty(); D.appendPt(Mouse()); sketching=true; }  // start acquisition processd
void myEndAcquisition() {if(sketching) {D.smoothen(5); for(int i=0; i<4; i++); D.refine(0,0); D.smoothen(10); D.resample(vc); P.setTo(D); sketching=false;}; }      // finish acquisition process
void myMousePressed() {
   if (Mouse().isInWindow()&&!keyPressed&&!sketching) pickedPoint=P.pickPoint(); 
   else if (Mouse().isInWindow()&&keyPressed&&(key=='d')) myStartAcquisition(); 
   } 
void myMouseReleased() {pickedPoint=null; myEndAcquisition();}
void myScale() {P.scaleWithMouse();}  
void myTranslate() {P.translateWithMouse();}
void myRotate() {P.rotateWithMouse();}

void myActions() { // actions to be executed at each frame
    scribe("Polygon or image morphing: Template for class projects Jarek Rossignac");               
    scribe("Control curve "+k+" is selected. Style "+str(style),1);               
   if(animate) scribe("Animating",2);               
   if((mousePressed)&&!keyPressed) {if(pickedPoint!=null) pickedPoint.trackMouse(); };
   if((mousePressed)&&keyPressed) {if(key=='m') myTranslate(); if(key=='t') myRotate(); if(key=='z') myScale(); if(key=='d') D.extendToMouse();};
   if(showFrames) {
       if(style==1) {} // linear interpolation                                                    // **P04 
       else if(style==2) {} // four-point interpolation                                           // **P04
       else if(style==3) {}  // smoother interpolation                                            // **P04
       else {cS.reset(kc); for(int i=0; i<kc; i++) {stroke(cS.next()); CP[i].drawSmooth(0,5);}; };  // Default style: (stroboscopic) shows only key-frames
       }; // end if(showFrames)
   if(showKeys) {stroke(metal); noFill(); for(int i=0; i<kc; i++) CP[i].drawSmooth(0,5); fill(metal); for(int i=0; i<kc; i++) CP[i].rP(0).showLabel(i); noFill();}; // show all keys
   if(sketching) {stroke(dred,50); noFill(); P.drawSmooth(0,5); fill(red,50); P.rP(0).show(4); fill(yellow,50); P.rP(1).show(3); stroke(red); noFill(); D.drawOpen(); noStroke();}
   if (showEkey) {stroke(red);  if(!sketching) fill(yellow); P.drawSmooth(0,5); fill(white); if(showVertices) P.showVertices(); fill(red); P.rP(0).show(4); fill(yellow); P.rP(1).show(3); };
   if(showMouseProjection) P.showMouseProjection(0,5);  // show closest point on P to mouse green if mouse is inside and red otherwise
   if(animate) {t++; if (t>=kc*32) t=0; 
     if(style==1) {} // linear motion                                                    // **P04 
     else if(style==2) {} // four-point motion                                           // **P04
     else if(style==3) {}  // smoother motion                                            // **P04
     else {stroke(red);  fill(yellow); CP[int(t/32)].drawSmooth(0,5);};  // Default style: jumps from frame to frame (stroboscopic)
     };
   };

